# import numpy as np
# from gym import spaces

# class Cliff_config:
    
#     def __init__(self, slippery_p):
#         '''
#         A configuration base class for the cliff
#         direction_p: the slippery parameter (1/3 <= p <= 1)
        
#         '''
#         self.slippery_p = slippery_p
        
#         self.map = np.array([[1, 1, 1, 1, 1, 1, 1], 
#                              [1, 1, 1, 1, 1, 1, 1], 
#                              [1, 1, 1, 1, 1, 1, 1], 
#                              [1, 1, 1, 1, 1, 1, 1], 
#                              [1, 0, 0, 0, 0, 0, 1]])
#         self.init_state = 14
#         self.max_steps = 50
#         self.states = np.arange(np.prod(self.map.shape))
#         self.off_cliff_states = self.states[self.map.flatten() == 0]
#         self.normal_states = set(self.states) - set(self.off_cliff_states)
#         self.normal_states = np.array(list(self.normal_states))
#         self.goal_state = int(np.prod(self.map.shape)-1)
        
#         self.reward_model = {"stay": -1., 
#                              "goal": 10., 
#                              "cliff": -10.}
        
#         # self.graph = {
#         # 0: [-1, 4, -1, 1],
#         # 1: [-1, 5, 0, 2],
#         # 2: [-1, 6, 1, 3],
#         # 3: [-1, 7, 2, -1 ],
#         # 4: [0, 8, -1, 5],
#         # 5: [-1, 4, -1, 1], # hole: return 0
#         # 6: [2, 10, 5, 7],
#         # 7: [-1, 4, -1, 1], #   hole: return 0
#         # 8: [4, 12, -1, 9],
#         # 9: [5, 13, 8, 10],
#         # 10: [6, 14, 9, 11],
#         # 11: [-1, 4, -1, 1], # hole: return 0
#         # 12: [-1, 4, -1, 1], #  hole: return 0
#         # 13: [9, -1, 12, 14],
#         # 14: [10, -1, 13, 15],
#         # 15: [0, 4, 0, 1] # goal: earn reward and return 0
#         # }
        
    
#     # @staticmethod
#     # def get_rnd_actions(action):
#     #     if action == 0: 
#     #         return [2,0,3]
#     #     elif action == 1:
#     #         return [2,1,3]
#     #     elif action == 2:
#     #         return [0,2,1]
#     #     elif action == 3:
#     #         return [0,3,1]
#     #     else:
#     #         raise
        
        
#     # def generate_trans_matrix(self, state_space, action_space):
#     #     ret = np.zeros(shape = (len(action_space), len(state_space), len(state_space)))
#     #     for a in action_space:
#     #         for s in state_space:
#     #             for ns in state_space:
#     #                 a_ls = self.get_rnd_actions(a)
#     #                 for ra in a_ls:
#     #                     p = self.direction_p if ra == a else (1-self.direction_p)/2
#     #                     if self.graph[s][ra] < 0:
#     #                         ret[a, s, ns] += p if s == ns else 0.
#     #                     else:
#     #                         ret[a, s, ns] += p if ns == self.graph[s][ra] else 0.
#     #     return ret

# class Cliff_Env(Cliff_config):
#     def __init__(self, random_factor):
#         Cliff_config.__init__(self, random_factor)
        
#         self.obs = 0
#         self.act_space = self.control_space = tuple([0,1,2,3]) # u,d,l,r
#         num_state = np.prod(self.map.shape)
#         self.state_space = tuple(list(range(num_state)))
#         # self.state_dim = 16
#         # self.action_dim = 1
        
#         self.obs_dim = num_state
#         self.act_dim = 1
#         self.act_num = 4
        
#         self.action_space = spaces.Discrete(4)
#         self.observation_space = spaces.Box(0.0, 1.0, shape=(num_state,))

#         # self.trans_matrix = self.generate_trans_matrix(self.state_space, self.control_space)
#         self.cnt = 0
#         self.done = False
        
        
#     def step(self, action, current_obs = None):
#         if action != -1:
#             assert action in self.control_space, f"illegal actoin {action}"
#         assert not self.done, "Call reset()"
#         obs = self.obs if current_obs is None else current_obs
#         self.obs = self._next_state(obs, action)
        
#         r = 0
#         done = False
#         if self.obs in self.off_cliff_states:
#             r += self.reward_model['cliff']
#             self.done = done = True
#         elif self.obs == self.goal_state:
#             r += self.reward_model['goal']
#             self.done = done = True
#         else:
#             r += self.reward_model['stay']
            
#         self.cnt += 1
#         if self.cnt >= self.max_steps:
#             self.done = done = True
#         return self.cont_obs, r, done, {}
    
#     @property
#     def cont_obs(self):
#         tmp = np.zeros(shape = (self.obs_dim,))
#         tmp[self.obs] = 1
#         return tmp

#     def reset(self, state=None):
#         self.cnt = 0
#         self.done = False
#         if state == "random":
#             self.obs = np.random.choice(self.normal_states)
#         elif state is None: 
#             self.obs = self.init_state
#         elif state in self.state_space:
#             self.obs = state
#         else:
#             print(state)
#             raise
#         return self.cont_obs
    

#     def state_to_coordinate(self, state):
#         assert 0 <= state <= self.obs_dim
#         nr, nc = self.map.shape
#         r = state // nc
#         c = state % nc
#         return (r, c)
    
#     def coordinate_to_state(self, cor):
#         r, c = cor
#         nr, nc = self.map.shape
#         return r*nc+c
        
    
#     def _next_state(self, obs, action):
#         # next_s = np.random.choice(self.state_space, p = self.trans_matrix[action, obs, :])
#         r, c = self.state_to_coordinate(obs)
#         # print(r, c)
#         if action == 0:
#             r = max(r-1, 0)
#         elif action == 1:
#             r = min(r+1, self.map.shape[0]-1)
#         elif action == 2:
#             c = max(c-1,0)
#         elif action == 3:
#             c = min(c+1, self.map.shape[1]-1)
#         elif action == -1:
#             return self.coordinate_to_state((r, c))
#         else:
#             raise
#         r, c = self._slip(r, c)
#         return self.coordinate_to_state((r, c))
    
#     def _slip(self, r, c):
#         if np.random.uniform() < self.slippery_p: # slippery happens
#             r = min(r+1, self.map.shape[0]-1)
#             # print("slipped")
#         return r, c
    
#     def render(self):
#         tmp = self.map.copy()
#         r,c = self.state_to_coordinate(self.obs)
#         tmp[r,c] = 9
#         print(tmp)
    
    
    
# if __name__ == "__main__":
#     env = Cliff_Env(0.3)
#     # print(env.trans_matrix)
#     print(env.reset())
#     while True:
#         env.render()
#         ipt = input("Input directions (W, A, S, D) or reset (R): ")
        
#         if ipt == 'r':
#             print(env.reset())
#         elif ipt == 'w': # up
#             print(env.step(0) )
#         elif ipt == 'a': # left
#             print(env.step(2))
#         elif ipt == 's': # down
#             print(env.step(1))
#         elif ipt == 'd': # right
#             print(env.step(3))
#         else:
#             print(env.obs)
        
        
        
import numpy as np
from gym import spaces

class Cliff_config:
    
    def __init__(self, slippery_p):
        '''
        A configuration base class for the cliff
        direction_p: the slippery parameter (1/3 <= p <= 1)
        
        '''
        self.slippery_p = slippery_p
        
        self.map = np.array([[1, 1, 1, 1, 1, 1, 1], 
                             [1, 1, 1, 1, 1, 1, 1], 
                             [1, 1, 1, 1, 1, 1, 1], 
                             [1, 1, 1, 1, 1, 1, 1], 
                             [1, 0, 0, 0, 0, 0, 1]])
        # self.map = np.array([[1,1,1,1],
        #                      [1,1,1,1],
        #                      [1,0,0,1]])
        self.init_state = np.arange(len(self.map.reshape(-1))).reshape(self.map.shape)[-1, 0]
        self.max_steps = 50
        self.states = np.arange(np.prod(self.map.shape))
        self.off_cliff_states = self.states[self.map.flatten() == 0]
        self.normal_states = set(self.states) - set(self.off_cliff_states)
        self.normal_states = np.array(list(self.normal_states))
        self.goal_state = int(np.prod(self.map.shape)-1)
        self.terminal_states = tuple(list(self.off_cliff_states)+[self.goal_state])
        
        self.reward_model = {"stay": -1., 
                             "goal": 18., 
                             "cliff": -10.}


class Cliff_Env(Cliff_config):
    def __init__(self, random_factor, continuous_state = True):
        Cliff_config.__init__(self, random_factor)
        
        self.obs = 0
        self.continuous_state = continuous_state
        self.act_space = self.control_space = tuple([0,1,2,3]) # u,d,l,r
        num_state = np.prod(self.map.shape)
        self.state_space = tuple(list(range(num_state)))
        # self.state_dim = 16
        # self.action_dim = 1
        
        self.obs_dim = num_state if continuous_state else 1
        self.obs_num = num_state
        self.act_dim = 1
        self.act_num = 4
        
        self.action_space = spaces.Discrete(4)
        self.observation_space = spaces.Box(0.0, 1.0, shape=(num_state,))

        # self.trans_matrix = self.generate_trans_matrix(self.state_space, self.control_space)
        self.cnt = 0
        self.done = False
        
        
    def step(self, action, current_obs = None):
        if action != -1:
            assert action in self.control_space, f"illegal actoin {action}"
        assert not self.done, "Call reset()"
        obs = self.obs if current_obs is None else current_obs
        self.obs = self._next_state(obs, action)
        
        r = 0
        done = False
        if self.obs in self.off_cliff_states:
            r += self.reward_model['cliff']
            self.done = done = True
        elif self.obs == self.goal_state:
            r += self.reward_model['goal']
            self.done = done = True
        else:
            r += self.reward_model['stay']
            
        self.cnt += 1
        if self.cnt >= self.max_steps:
            self.done = done = True

        return self.ret_obs, r, done, {}
    
    @property
    def ret_obs(self):
        return self.cont_obs if self.continuous_state else self.obs
    
    @property
    def cont_obs(self):
        tmp = np.zeros(shape = (self.obs_dim,))
        tmp[self.obs] = 1
        return tmp
    

    def reset(self, state=None):
        self.cnt = 0
        self.done = False
        if state == "random":
            self.obs = np.random.choice(self.normal_states)
        elif state is None: 
            self.obs = self.init_state
        elif state in self.state_space:
            self.obs = state
        else:
            print(state)
            raise
        
        return self.ret_obs
    

    def state_to_coordinate(self, state):
        assert 0 <= state <= self.obs_num
        nr, nc = self.map.shape
        r = state // nc
        c = state % nc
        return (r, c)
    
    def coordinate_to_state(self, cor):
        r, c = cor
        nr, nc = self.map.shape
        return r*nc+c
        
    
    def _next_state(self, obs, action, slip = True):
        # next_s = np.random.choice(self.state_space, p = self.trans_matrix[action, obs, :])
        r, c = self.state_to_coordinate(obs)
        # print(r, c)
        if action == 0:
            r = max(r-1, 0)
        elif action == 1:
            r = min(r+1, self.map.shape[0]-1)
        elif action == 2:
            c = max(c-1,0)
        elif action == 3:
            c = min(c+1, self.map.shape[1]-1)
        elif action == -1:
            return self.coordinate_to_state((r, c))
        else:
            raise
        if slip:
            r, c = self._slip(r, c)
        return self.coordinate_to_state((r, c))
    
    def _slip(self, r, c):
        if np.random.uniform() < self.slippery_p: # slippery happens
            r = min(r+1, self.map.shape[0]-1)
            # print("slipped")
        return r, c
    
    def render(self):
        tmp = self.map.copy()
        r,c = self.state_to_coordinate(self.obs)
        tmp[r,c] = 9
        print(tmp)
        
    