import time
from multiprocessing import Process

import os





def run_processes(total_tasks, num_processes = None):
    if num_processes is None:
        num_processes = os.cpu_count()
    num_total_tasks = len(total_tasks)
    processes = []
    tasks_completed = 0
    task_ptr = 0
    
    while tasks_completed < num_total_tasks:
        while len(processes) < num_processes and tasks_completed < num_total_tasks:
            p = total_tasks[task_ptr]
            task_ptr += 1
            p.start()
            processes.append(p)
            tasks_completed += 1

        for p in processes:
            p.join(timeout=0)  # Non-blocking join

            if not p.is_alive():
                processes.remove(p)

    # Wait for all remaining processes to finish
    for p in processes:
        p.join()

    print("All tasks completed.")


if __name__ == "__main__":
    def worker(id_):
        # Simulating some work
        time.sleep(1)
        print(f"{id_}, Task completed.")
    
    num_processes = 4
    total_tasks = 10
    
    tasks = [Process(target=worker, args=(id_, )) for id_ in range(100)]

    run_processes(num_processes, tasks)
