# Dependencies
Core dependencies:
* Python 3.7
* OpenAI Gym: `./core_dependencies/gym`
* OpenAI Baselines: `./core_dependencies/baselines`
* Stable baselines: `./atari_tasks/stable_baselines`
* Tensorflow 1.14.0

# Classical Environment
In `./classical_tasks/`.
## Training
In each environment folder, run `train.py` script to train the model for the SMBS method. The following show an example:
```bash
python train.py --delay_steps 5 \
--randomness_param 0.15 \
--work_directory "./save/smbs/d5_r015/train0/" \
--alpha 0.0 \
```


# Atari Environment
In `./atari_tasks/`. The repository is adapted from `https://github.com/galdl/rl_delay_atari`, please read instructions for installation. 
## Training
In `./atari_tasks` folder, run `run_experiment_rl_delay.py` script to train the model for the SMBS/Delayed-Q/AMDP method. The following show an example for training in Freeway-v0:
```bash
python run_experiment_rl_delay.py freeway SMBS
```